#ifndef _HARK__BEAMFORMING__ML_H__INCLUDED_
#define _HARK__BEAMFORMING__ML_H__INCLUDED_ 1

#include "BF.h"

namespace BF
{
    class CML : public BF
    {
    public:	CML(int numFreq, int lowerfreq, int upperfreq, int samplingRate, double soundSpeed, double regFactor, double epsAtKAsclr);
	virtual ~CML();

    public:
	virtual BfType getBfAlgorithmType() const { return BfML; }

	virtual void updateSources(const std::vector<SourceLocation> &sourcePositions);
	virtual void adaptSeparationMatrices();

    private:
	double regFactor;
	double epsAtKAsclr;
    };
}

#endif
